//*****************************************************************************
//*****************************************************************************
//  FILENAME:  UART0.h
//  Version: 5.3, Updated on 2012/9/21 at 11:59:48
//  Generated by PSoC Designer 5.3.2710
//
//  DESCRIPTION:  UART User Module C Language interface file.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress Semiconductor 2012. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef UART0_INCLUDE
#define UART0_INCLUDE

// include the global header file
#include <m8c.h>

#define UART0_RXBUF_ENABLE 0

//-------------------------------------------------
// Prototypes of the UART0 API.
//-------------------------------------------------

#if ( UART0_RXBUF_ENABLE )
extern char UART0_aRxBuffer[];
extern BYTE UART0_bRxCnt;
extern BYTE UART0_fStatus;
#endif



// Create pragmas to support proper argument and return value passing

#pragma fastcall16  UART0_SetTxIntMode
#pragma fastcall16  UART0_EnableInt
#pragma fastcall16  UART0_DisableInt
#pragma fastcall16  UART0_Start
#pragma fastcall16  UART0_Stop
#pragma fastcall16  UART0_SendData
#pragma fastcall16  UART0_bReadTxStatus
#pragma fastcall16  UART0_bReadRxData
#pragma fastcall16  UART0_bReadRxStatus
#pragma fastcall16  UART0_PutSHexByte
#pragma fastcall16  UART0_PutSHexInt
#pragma fastcall16  UART0_CPutString
#pragma fastcall16  UART0_PutString
#pragma fastcall16  UART0_PutChar
#pragma fastcall16  UART0_Write
#pragma fastcall16  UART0_CWrite

#pragma fastcall16  UART0_cGetChar
#pragma fastcall16  UART0_cReadChar
#pragma fastcall16  UART0_iReadChar
#pragma fastcall16  UART0_IntCntl
#pragma fastcall16  UART0_TxIntMode
#pragma fastcall16  UART0_PutCRLF

#if ( UART0_RXBUF_ENABLE )
#pragma fastcall16  UART0_CmdReset
#pragma fastcall16  UART0_bCmdCheck
#pragma fastcall16  UART0_bErrCheck
#pragma fastcall16  UART0_bCmdLength
#pragma fastcall16  UART0_szGetParam
#pragma fastcall16  UART0_szGetRestOfParams
#endif

//**************************************************
// Prototypes of UART API.
//**************************************************
extern void  UART0_SetTxIntMode(BYTE bTxIntMode);
extern void  UART0_EnableInt(void);
extern void  UART0_DisableInt(void);
extern void  UART0_Start(BYTE bParitySetting);
extern void  UART0_Stop(void);
extern void  UART0_SendData(BYTE bTxData);
extern BYTE  UART0_bReadTxStatus(void);
extern BYTE  UART0_bReadRxData(void);
extern BYTE  UART0_bReadRxStatus(void);

// High level TX functions
extern void   UART0_CPutString(const BYTE * szRomString);
extern void   UART0_PutString(BYTE * szRamString);
extern void   UART0_PutChar(CHAR cData);
extern void   UART0_Write(BYTE * szRamString, BYTE bCount);
extern void   UART0_CWrite(const BYTE * szRomString, INT iCount);
extern void   UART0_PutSHexByte(BYTE bValue);
extern void   UART0_PutSHexInt(INT iValue);
extern void   UART0_PutCRLF(void);
extern void   UART0_TxIntMode(BYTE bMask);

// High level RX functions
extern CHAR   UART0_cGetChar(void);
extern CHAR   UART0_cReadChar(void);
extern INT    UART0_iReadChar(void);
extern void   UART0_IntCntl(BYTE bMask);

#if ( UART0_RXBUF_ENABLE )
extern void   UART0_CmdReset(void);
extern BYTE   UART0_bCmdCheck(void);
extern BYTE   UART0_bErrCheck(void);
extern BYTE   UART0_bCmdLength(void);
extern BYTE * UART0_szGetParam(void);
extern BYTE * UART0_szGetRestOfParams(void);
#endif

//-------------------------------------------------
// Defines for UART0 API's.
//-------------------------------------------------



//------------------------------------
//  Parity masks
//------------------------------------
#define  UART0_PARITY_NONE        0x00
#define  UART0_PARITY_EVEN        0x02
#define  UART0_PARITY_ODD         0x06
//------------------------------------
//  Transmitter Status Register masks
//------------------------------------
#define  UART0_TX_COMPLETE        0x20
#define  UART0_TX_BUFFER_EMPTY    0x10

//------------------------------------
//  Receiver Status Register masks
//------------------------------------
#define  UART0_RX_ACTIVE          0x10
#define  UART0_RX_COMPLETE        0x08
#define  UART0_RX_REG_FULL        0x08
#define  UART0_RX_PARITY_ERROR    0x80
#define  UART0_RX_OVERRUN_ERROR   0x40
#define  UART0_RX_FRAMING_ERROR   0x20
#define  UART0_RX_ERROR           0xE0
#define  UART0_RX_NO_ERROR        0xE0          // This symbol is deprecated and will removed in the future

#define  UART0_RX_NO_DATA         0x01

#define  UART0_RX_BUF_ERROR               0xF0  // Mask for any Rx that may occur.
#define  UART0_RX_BUF_OVERRUN             0x10  // This indicates the software buffer has
                                                           // been over run.
#define  UART0_RX_BUF_CMDTERM             0x01  // Command terminator has been received.

// Interrupt control used with  UART0_IntCntl() function
#define UART0_ENABLE_RX_INT  0x01
#define UART0_ENABLE_TX_INT  0x02
#define UART0_DISABLE_RX_INT 0x00
#define UART0_DISABLE_TX_INT 0x00

// Interrupt Modes
#define UART0_INT_MODE_TX_REG_EMPTY 0x00
#define UART0_INT_MODE_TX_COMPLETE  0x01

//-------------------------------------------------
// Register Address Constants for UART0
//-------------------------------------------------

#pragma ioport  UART0_TX_CONTROL_REG:   0x02b               // Control register
BYTE            UART0_TX_CONTROL_REG;
#pragma ioport  UART0_TX_SHIFT_REG: 0x028                   // TX Shift Register register
BYTE            UART0_TX_SHIFT_REG;
#pragma ioport  UART0_TX_BUFFER_REG:    0x029               // TX Buffer Register
BYTE            UART0_TX_BUFFER_REG;
#pragma ioport  UART0_TX_FUNC_REG:  0x128                   // Function register
BYTE            UART0_TX_FUNC_REG;
#pragma ioport  UART0_TX_INPUT_REG: 0x129                   // Input register
BYTE            UART0_TX_INPUT_REG;
#pragma ioport  UART0_TX_OUTPUT_REG:    0x12a               // Output register
BYTE            UART0_TX_OUTPUT_REG;
#pragma ioport  UART0_RX_CONTROL_REG:   0x02f               // Control register
BYTE            UART0_RX_CONTROL_REG;
#pragma ioport  UART0_RX_SHIFT_REG: 0x02c                   // RX Shift Register register
BYTE            UART0_RX_SHIFT_REG;
#pragma ioport  UART0_RX_BUFFER_REG:    0x02e               // RX Buffer Register
BYTE            UART0_RX_BUFFER_REG;
#pragma ioport  UART0_RX_FUNC_REG:  0x12c                   // Function register
BYTE            UART0_RX_FUNC_REG;
#pragma ioport  UART0_RX_INPUT_REG: 0x12d                   // Input register
BYTE            UART0_RX_INPUT_REG;
#pragma ioport  UART0_RX_OUTPUT_REG:    0x12e               // Output register
BYTE            UART0_RX_OUTPUT_REG;

#pragma ioport  UART0_TX_INT_REG:       0x0e1              // TX Interrupt Mask Register
BYTE            UART0_TX_INT_REG;
#pragma ioport  UART0_RX_INT_REG:       0x0e1              // RX Interrupt Mask Register
BYTE            UART0_RX_INT_REG;

// Masks to use with UART0_TX_INT_REG and UART0_RX_INT_REG Registers
#define UART0_TX_INT_MASK           (0x04) // TX Interrupt register Mask
#define UART0_RX_INT_MASK           (0x08) // RX Interrupt register Mask


//-------------------------------------------
//       WARNING WARNING WARNING
// The following defines and function prototypes
// are for backwards compatibility only and
// should not be used for new designs.
//-------------------------------------------
#pragma fastcall16  bUART0_ReadTxStatus
#pragma fastcall16  bUART0_ReadRxData
#pragma fastcall16  bUART0_ReadRxStatus
extern BYTE  bUART0_ReadTxStatus(void);
extern BYTE  bUART0_ReadRxData(void);
extern BYTE  bUART0_ReadRxStatus(void);
//------------------------------------
//  Parity masks
//------------------------------------
#define  UART_PARITY_NONE        0x00
#define  UART_PARITY_EVEN        0x02
#define  UART_PARITY_ODD         0x06

//------------------------------------
//  Transmitter Status Register masks
//------------------------------------
#define  UART_TX_COMPLETE        0x20
#define  UART_TX_BUFFER_EMPTY    0x10

//------------------------------------
//  Receiver Status Register masks
//------------------------------------
#define  UART_RX_ACTIVE          0x10
#define  UART_RX_COMPLETE        0x08
#define  UART_RX_PARITY_ERROR    0x80
#define  UART_RX_OVERRUN_ERROR   0x40
#define  UART_RX_FRAMING_ERROR   0x20
#define  UART_RX_NO_ERROR        0xE0

#endif
//-------------------------------------------
//             END WARNING
//-------------------------------------------
// end of file UART0.h
